var app = angular.module('MatApp', []);

app.config(function ($sceDelegateProvider) {
    $sceDelegateProvider.resourceUrlWhitelist(['self', '**']);
});

app.factory('DataService', function ($http, $window, $location) {
    var getData = function (json) {
    			
    			 if (typeof json == 'undefined') var json = "index";
    			 var jsonoriginal = json;
                 json = "/ga/" + json;
                
                // getting locale
                 var lang = $window.location.href.match(/[a-zA-Z]{2}-[a-zA-Z]{2,3}/); /*locale is identified from href instead of navigator language as the geo-detection URL will be different from navigator language for Asian countries*/
 				 
 				 				
 				if (typeof (getUrlParameter_ng('jad')) == "undefined") {
 					var addparameter = '';
 				} else {
 					var addparameter = "-" + (getUrlParameter_ng('jad'));
 				}
 				
 				if (jsonoriginal == "header") addparameter = "";
 				if (jsonoriginal == "footer") addparameter = "";
 				
				// adding environment
                var env='';
                if($window.location.origin == "http://play.maxsteel.com")
                                env = "http://maxsteelweb-dev01-cdn.mattelext.fuelindustries.com/";
                //return $http.get(env + lang + json + addparameter + '.json');
				
                return $http.get("/data/" + lang + json + addparameter + '.json');//(env + lang + json +'.json');				
    };
    return {
        getData: getData
    };
});


app.factory('TemplateService', function ($http) {
    var getTemplates = function (module) {
			
			// dynamicaly load less style
			var template_stylesheet = 'modules/'+ module +'.less';

			// only if less file exist
			if (UrlExists(template_stylesheet)) {
			
				var link  = document.createElement('link');
				link.rel  = "stylesheet";
				link.type = "text/less";
				link.href = template_stylesheet;
				// Pushing sheet to less
				less.sheets.push(link);
			}
			// returning module html for rendering
			return $http.get('modules/'+ module +'.html');
    };

	return {
        getTemplates: getTemplates
    };
});

app.factory('videoFactory',function($http){
    var getVideos = function (json) {
		return $http.get(json);
    };
    
    return {
        getVideos: getVideos
    };
});

app.factory('toysFactory',function($http){
    var getToys = function (locale, category, $scope) {
    	if (typeof locale == 'undefined') var locale = "en-us";

		var config = {BrandName: 'max steel', LocaleName: locale};
		$http.post( 'http://product.mattel.com/api/Product/GetProductList', config).then( function(data) {
			var toysarr = data.data;
			angular.forEach(toysarr, function(value, key) {
			  var config_detail = {
			    "brandName": "max steel",
			    "localeName": locale,
			    "pids": value.productId,
			    "guid": "606fa44f-7bb9-416e-b1e7-12c0aeca57fe",
			    "seoName": value.seoCharecter,
			    "categoryName": value.seoCategory
			  }
			  $http.post( 'http://product.mattel.com/api/Product/GetProductDetails', config_detail).then( function(data2) {
			  	var toysdetail = data2.data;
			  	toysarr[key].allimages = toysdetail.productDetail.mediaDetail;
			  	toysarr[key].retailer = toysdetail.productDetail.retailers;
			  });
			});
			$scope.toys = toysarr;
			
		});
					
		return $scope.toysarr;
		
    };

    return {
        getToys: getToys
    };
});

app.filter('dateDiff', function () {
  var magicNumber = (1000 * 60 * 60 * 24);

  return function (toDate, fromDate) {
  

    if(toDate && fromDate){
    
    	var date1 = new Date(toDate);
    	var date2 = new Date(fromDate);

    
    
      var dayDiff = Math.floor((date1 - date2) / magicNumber);
      if (angular.isNumber(dayDiff)){
        return dayDiff ;
      }
    }
  };
});


app.filter('dateDiff_now', function () {
  var magicNumber = (1000 * 60 * 60 * 24);

  return function (toDate) {
  

    if(toDate){
    
    	var date1 = new Date(toDate);
    	var date2 = new Date();

    
    
      var dayDiff = Math.floor((date1 - date2) / magicNumber);
      if (angular.isNumber(dayDiff)){
        return dayDiff ;
      }
    } else {
    	return "-1";
    }
  };
});

app.filter('iif', function () {
   return function(input, trueValue, falseValue) {
        return input ? trueValue : falseValue;
   };
});

app.filter('removeSpaces', [function() {
    return function(string) {
        if (!angular.isString(string)) {
            return string;
        }
        return string.replace(/[\s]/g, '');
    };
}]);


function UrlExists(url)
{
    var http = new XMLHttpRequest();
    http.open('HEAD', url, false);
    http.send(null);
    return http.status!=404;
}

var getUrlParameter_ng = function getUrlParameter_ng(sParam) {
	

    var sPageURL = decodeURIComponent(window.location.search.substring(1)),
        sURLVariables = sPageURL.split('&'),
        sParameterName,
        i;

    for (i = 0; i < sURLVariables.length; i++) {
        sParameterName = sURLVariables[i].split('=');

        if (sParameterName[0] === sParam) {
            return sParameterName[1] === undefined ? true : sParameterName[1];
            
        }
    }
};