app.directive('contentItem', function($compile, TemplateService) {
	// rendering content for modules
	var linker = function(scope, element, attrs) {
		var output = '';
		// getting template
		TemplateService.getTemplates(scope.content.type).then(function(response) {
			// generating output form current template type						
			output += response.data;
			element.html(output);
			$compile(element.contents())(scope);
		});
	};
	// returning content to HTML
	return {
		restrict: 'E',
		link: linker,
		scope: {
			content: '='
		}
	};
});

app.directive("repeatComplete",function( $rootScope ) {
	var uuid = 0;
	function compile( tElement, tAttributes ) {
		var id = ++uuid;
		tElement.attr( "repeat-complete-id", id );
		tElement.removeAttr( "repeat-complete" );
		var completeExpression = tAttributes.repeatComplete;
		var parent = tElement.parent();
		var parentScope = ( parent.scope() || $rootScope );
		var unbindWatcher = parentScope.$watch(
			function() {
				var lastItem = parent.children( "*[ repeat-complete-id = '" + id + "' ]:last" );
				if ( ! lastItem.length ) {
					return;
				}
				var itemScope = lastItem.scope();
				if ( itemScope.$last ) {
					unbindWatcher();
					itemScope.$eval( completeExpression );
				}
			}
		);
	}
	return({
		compile: compile,
		priority: 1001,
		restrict: "A"
	});
});

app.directive('ngBindHtmlUnsafe', ['$sce', function($sce){
    return {
        scope: {
            ngBindHtmlUnsafe: '=',
        },
        template: "<div ng-bind-html='trustedHtml'></div>",
        link: function($scope, iElm, iAttrs, controller) {
            $scope.updateView = function() {
                $scope.trustedHtml = $sce.trustAsHtml($scope.ngBindHtmlUnsafe);
            }

            $scope.$watch('ngBindHtmlUnsafe', function(newVal, oldVal) {
                $scope.updateView(newVal);
            });
        }
    };
}]);


app.directive('repeatDone', [function () {
  return {
    restrict: 'A',
     link: function (scope, element, iAttrs) {

          var parentScope = element.parent().scope();

          if (scope.$last){
               
               onXMLLoad();
                 
          }
        }
      };
    }])

